import React from 'react';
import { backgroundColor } from '@atlaskit/adf-schema';
import { changeColor } from './commands';
import { createPlugin, highlightPluginKey } from './pm-plugin';
import { ToolbarHighlightColorWithIntl as ToolbarHighlightColor } from './ui/ToolbarHighlightColor';
export const highlightPlugin = ({
  api
}) => {
  var _api$analytics;
  const editorAnalyticsAPI = api === null || api === void 0 ? void 0 : (_api$analytics = api.analytics) === null || _api$analytics === void 0 ? void 0 : _api$analytics.actions;
  return {
    name: 'highlight',
    commands: {
      changeColor: changeColor(editorAnalyticsAPI)
    },
    marks() {
      return [{
        name: 'backgroundColor',
        mark: backgroundColor
      }];
    },
    pmPlugins: () => [{
      name: 'highlight',
      plugin: () => createPlugin({
        api
      })
    }],
    getSharedState(editorState) {
      if (!editorState) {
        return;
      }
      return highlightPluginKey.getState(editorState);
    },
    primaryToolbarComponent: ({
      editorView,
      popupsMountPoint,
      popupsBoundariesElement,
      popupsScrollableElement,
      disabled,
      isToolbarReducedSpacing,
      dispatchAnalyticsEvent
    }) => /*#__PURE__*/React.createElement(ToolbarHighlightColor, {
      popupsMountPoint: popupsMountPoint,
      popupsBoundariesElement: popupsBoundariesElement,
      popupsScrollableElement: popupsScrollableElement,
      disabled: disabled,
      isToolbarReducedSpacing: isToolbarReducedSpacing,
      dispatchAnalyticsEvent: dispatchAnalyticsEvent,
      pluginInjectionApi: api
    })
  };
};